#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct elem elem;

struct elem {
	
	char *name;
	struct elem *next;
};

elem *create_element (char *name);

elem *head_element (elem *first, elem *new_element); // add an element to the head of the list

elem *end_element (elem *start, elem *new_element); // add an element to the end of list

elem *find_element (elem *start, char *name);

elem *print_data (elem *start); // print every element of the list

elem *del_end (elem *start); // delete last element

elem *del_head (elem *start); // delete first element

elem *apply (elem *start, void (*function) (elem *start, void *), void *fn_arg);

elem *free_all(elem *start);


elem 
*create_element (char *name)
{
	elem *new;
	
	new = malloc(sizeof(elem));
	
	new->name = malloc((strlen(name) + 1) * sizeof(char));
	
	new->name = name;
	new->next = NULL;
	
	return new;	
}

elem 
*find_element (elem *start, char *name)
{
	while (start != NULL) {
		
		if (strcmp(start->name, name) == 0)
			return start;
		
		start = start->next;
	}
	
	printf("no such data\n");
	return NULL; 
}

elem 
*head_element(elem *first, elem *new_element)
{
	new_element->next = first;
	
	return new_element;
}

elem 
*end_element (elem *start, elem *new_element)
{
	while (start != NULL) {
		
		if (start->next == NULL) {
			start->next = new_element;
			new_element->next = NULL;
		}
		
		start = start->next;
	}
	
	return new_element;
}

elem 
*del_end (elem *start) {
	
	elem *prev;
	
	while (start != NULL) {
		
		if (start->next == NULL) {
		
			prev->next = NULL;
			free(start);
			break;
		}
		prev = start;
		start = start->next;
	}
	
	return 0;
}

elem 
*del_head (elem *start) {
	
	elem *prev;
	
	prev = start;
	start = start->next;
	free(prev);
	
	return start;
}

elem 
*print_data (elem *start) {
	
	if (start == NULL)
		printf("no element - no data\n");
		
	while (start != NULL) {
		
		printf("%s\n", start->name);
		
		start = start->next;
	}
	
	return 0;
}

elem 
*apply (elem *start, void (*function) (elem *start, void *), void *fn_arg) {

	while (start != NULL) {
		function(start, fn_arg);
		start = start->next;
	}
	
	return 0;	
}

elem 
*free_all (elem *start) {
	
	elem *next;
	
	while (start != NULL) {
		next = start->next;
		free(start);		
		start = next;
	}
	
	free(start);
	
	return 0;
}

